Models/Post.cs
using System.ComponentModel.DataAnnotations;

namespace VUBgram.Models {
  public class Post {
    [Key]
    public int Id { get; set; }
    
    [Required]
    public string URL { get; set; }
    
    public string Description { get; set; }
    
    public int Likes { get; set; }
  }
}

Models/VUBgramDbContext.cs
using Microsoft.EntityFrameworkCore;

namespace VUBgram.Models {
  public class VUBgramDbContext : DbContext {
    public VUBgramDbContext(DbContextOptions<VUBgramDbContext> options) : base(options) { }

    public DbSet<Post> Posts { get; set; }
  }
}

Pages/Error.cshtml.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace VUBgram.Pages {
  [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
  public class ErrorModel : PageModel {
    public string RequestId { get; set; }

    public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);

    private readonly ILogger<ErrorModel> _logger;

    public ErrorModel(ILogger<ErrorModel> logger) {
      _logger = logger;
    }

    public void OnGet() {
      RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier;
    }
  }
}

Pages/Index.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace VUBgram.Pages {
  public class IndexModel : PageModel {
    private readonly ILogger<IndexModel> _logger;

    public IndexModel(ILogger<IndexModel> logger) {
      _logger = logger;
    }

    public void OnGet() {

    }
  }
}

Pages/Posts/Create.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using VUBgram.Models;
using System.Collections.Generic;
using System.Linq;
using Microsoft.EntityFrameworkCore;
using System.Threading.Tasks;

namespace VUBgram.Pages.Posts {
  public class CreateModel : PageModel {
    private readonly VUBgramDbContext db;

    public CreateModel(VUBgramDbContext db) {
      this.db = db;
    }

    public void OnGet(string search) {
    }

    public async Task<IActionResult> OnPostAsync() {
      if (!ModelState.IsValid) {
        return Page();
      }

      db.Posts.Add(Post);
      await db.SaveChangesAsync();

      return RedirectToPage("/Posts/Index");
    } 

    [BindProperty]
    public Post Post { get; set; }
  }
}

Pages/Posts/Edit.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using VUBgram.Models;
using System.Collections.Generic;
using System.Linq;
using Microsoft.EntityFrameworkCore;
using System.Threading.Tasks;

namespace VUBgram.Pages.Posts {
  public class EditModel : PageModel {
    private readonly VUBgramDbContext db;

    public EditModel(VUBgramDbContext db) {
      this.db = db;
    }

    public async Task<IActionResult> OnGetAsync(int id) {
      Post = await db.Posts.FindAsync(id);

      if (Post == null) {
        return RedirectToPage("/Posts/Index");
      }

      return Page();
    }

    public async Task<IActionResult> OnPostAsync() {
      if (!ModelState.IsValid) {
        return Page();
      }

      db.Attach(Post).State = EntityState.Modified;

      try {
        await db.SaveChangesAsync();
      } catch (DbUpdateConcurrencyException) {
      }

      return RedirectToPage("/Posts/Index");
    }

    [BindProperty]
    public Post Post { get; set; }
  }
}

Pages/Posts/Index.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using VUBgram.Models;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;
using System;

namespace VUBgram.Pages.Posts {
  public class IndexModel : PageModel {
    private readonly VUBgramDbContext db;

    public IndexModel(VUBgramDbContext db) {
      this.db = db;
    }

    public void OnGet(string search) {
      if (search != null) {
        Posts =
          from p in db.Posts
          where p.Description.Contains(search)
          select p;
      } else {
        Posts = db.Posts;
      }
    }

    public async Task<IActionResult> OnPostDeleteAsync(int id) {
      var post = await db.Posts.FindAsync(id);
      if (post == null) {
        return NotFound();
      }
      db.Posts.Remove(post);
      await db.SaveChangesAsync();

      return RedirectToPage("/Posts/Index");
    }

    public IEnumerable<Post> Posts { get; set; }
  }
}

Pages/Index.cshtml
@page
@model IndexModel
@{
    ViewData["Title"] = "Home page";
}

<div class="text-center">
    <h1 class="display-4">VUBgram</h1>
    <img src="img/vub-logo.png" alt="VUB logo">
</div>

Pages/Posts/Create.cshtml
@page
@model CreateModel
@{
  ViewData["Title"] = "Postovi";
}


<div class="container">
  <div class="row">
    <div class="col-sm">
      <h2>Unos novog posta</h2>
      <form method="post">
        <div class="form-group">
          URL:
          <input asp-for="Post.URL">
        </div>
        <div class="form-group">
          Opis:
          <input asp-for="Post.Description">
        </div>
        <div class="form-group">
          Broj lajkova:
          <input asp-for="Post.Likes">
        </div>
        <input type="submit" value="Unesi">
      </form>
    </div>
  </div>
</div>

Pages/Posts/Edit.cshtml
@page
@model EditModel
@{
  ViewData["Title"] = "Postovi";
}


<div class="container">
  <div class="row">
    <div class="col-sm">
      <h2>Izmjena posta</h2>
      <form method="post">
        <input asp-for="Post.Id" type="hidden">
        <div class="form-group">
          URL:
          <input asp-for="Post.URL">
        </div>
        <div class="form-group">
          Opis:
          <input asp-for="Post.Description">
        </div>
        <div class="form-group">
          Broj lajkova:
          <input asp-for="Post.Likes">
        </div>
        <input type="submit" value="Unesi">
      </form>
    </div>
  </div>
</div>

Pages/Posts/Index.cshtml
@page
@model IndexModel
@{
  ViewData["Title"] = "Postovi";
}

<form>
  <div class="form-group">
    <label for="search">Pretraga:</label>
    <input type="text" name="search" class="form-control" placeholder="Upišite tekst za pretragu...">
  </div>
</form>

<div class="text-center">
  <h1 class="display-4">
    Postovi
  </h1>

  @foreach (var post in @Model.Posts) {
    <h4>@post.Description (@post.Likes)</h4>
    <a href="@post.URL">@post.URL</a>
    <form method="post" class="d-inline">
      <a asp-page="/Posts/Edit" asp-route-id="@post.Id" class="btn btn-primary btn-sm">Edit</a>
      <input type="submit" asp-page-handler="Delete" asp-route-id="@post.Id" class="btn btn-danger btn-sm" onclick="return confirm('Jeste li sigurni da želite obrisati?');" value="Obriši">
    </form>
  }
</div>

Pages/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">

<head>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="">
  <meta name="author" content="">

  <title>VUBgram</title>

  <!-- Bootstrap core CSS -->
  <link href="~/lib/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">

  <!-- Custom styles for this template -->
  <link href="~/css/simple-sidebar.css" rel="stylesheet">

</head>

<body>

  <div class="d-flex" id="wrapper">

    <partial name="_Sidebar">

    <!-- Page Content -->
    <div id="page-content-wrapper">

      <nav class="navbar navbar-expand-lg navbar-light bg-light border-bottom">
        <button class="btn btn-success" id="menu-toggle">Prebaci izbornik</button>

        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent"
          aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarSupportedContent">
          <ul class="navbar-nav ml-auto mt-2 mt-lg-0">
            <li class="nav-item active">
              <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="#">Link</a>
            </li>
            <li class="nav-item dropdown">
              <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown"
                aria-haspopup="true" aria-expanded="false">
                Dropdown
              </a>
              <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                <a class="dropdown-item" href="#">Action</a>
                <a class="dropdown-item" href="#">Another action</a>
                <div class="dropdown-divider"></div>
                <a class="dropdown-item" href="#">Something else here</a>
              </div>
            </li>
          </ul>
        </div>
      </nav>

      <div class="container-fluid">
        @RenderBody()
      </div>
    </div>
    <!-- /#page-content-wrapper -->

  </div>
  <!-- /#wrapper -->

  <!-- Bootstrap core JavaScript -->
  <script src="~/lib/jquery/dist/jquery.min.js"></script>
  <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>

  <!-- Menu Toggle Script -->
  <script>
    $("#menu-toggle").click(function (e) {
      e.preventDefault();
      $("#wrapper").toggleClass("toggled");
    });
  </script>

</body>

</html>

Pages/Shared/_Sidebar.cshtml
<!-- Sidebar -->
<div class="bg-dark border-right" id="sidebar-wrapper">
  <div class="sidebar-heading text-white">VUBgram</div>
  <div class="list-group list-group-flush">
    <a asp-page="/Index" class="list-group-item list-group-item-action bg-dark text-white">Naslovnica</a>
    <a asp-page="/Posts/Index" class="list-group-item list-group-item-action bg-dark text-white">Postovi</a>
    <a asp-page="/Posts/Create" class="list-group-item list-group-item-action bg-dark text-white">Novi post</a>
  </div>
</div>
<!-- /#sidebar-wrapper -->